//  Code rewritten from 0.5.3 version, to avoid the call to initwithpath (TB 1.5 only)

var MBstrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].
			getService(Components.interfaces.nsIStringBundleService);
var mboximportbundle = MBstrBundleService.createBundle("chrome://mboximport/locale/mboximport.properties"); 
var mboximportbundle2 = MBstrBundleService.createBundle("chrome://messenger/locale/mime.properties"); 
var gEMLimported;

function openMboxDialog() {
	window.openDialog("chrome://mboximport/content/mboxdialog.xul","", "chrome,modal,centerscreen");
}


function msgFolder2LocalFile(msgFolder) {
	if (msgFolder.filePath) 
			// This method is much better, because it should works with every charset
			// but it's available just in TB 1.5
			 var LocalFile= msgFolder.filePath;
	else {
			// Old method that can be used with TB 1.0, but doesn't seem to work with every charset
			var LocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			LocalFile.initWithPath(msgFolder.path.nativePath);
		}
	return LocalFile;
}


// The arguments of trytocopy are
// file=the file to import as nsILocalFile
// filename=the name of the file to import
// msgFolder=the folder as nsImsgFolder
//
function trytocopy(file,filename,msgFolder,keepstructure) {
	// If the file isn't mbox format, alert, but doesn't exit (it did in pre 0.5.8 version and lower)
	// In fact sometimes TB can import also corrupted mbox files
	if (! isMbox(file)) {
		var continuebundle = MBstrBundleService.createBundle("chrome://messenger/locale/filter.properties");
		// We take the "Continue" label from another file...
		var continuelabel = continuebundle.GetStringFromName("continueButtonLabel");
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var flags = prompts. BUTTON_TITLE_CANCEL     * prompts.BUTTON_POS_0 +
	            prompts.BUTTON_TITLE_IS_STRING   *prompts.BUTTON_POS_1   + prompts.BUTTON_POS_0_DEFAULT;
		var string = ("\"" + filename + "\" " + mboximportbundle.GetStringFromName("nomboxfile"));
 		var button = prompts.confirmEx(window, "MboxImport", string , flags,  "Button 0", continuelabel, "", null, {});
		if (button==0)
			return false;
	}

	// TB 3 has not path attribute for nsIMsgFolder
	if (msgFolder.path)
		var destfolderpath = msgFolder.path.nativePath;
	else
		var destfolderpath = msgFolder.filePath.path;

	// add to the original filename a random number in range 0-999
	var newfilename = filename+Math.floor(Math.random()*999);
	var k = 0;
	// if exists a subfolder with this name, we change the random number, with max. 500 tests
	while (msgFolder.containsChildNamed(newfilename)) {
		newfilename = filename+Math.floor(Math.random()*999);
		k++;
		if (k >500) {
			alert("Can't find a good name");
			return false;
		}
	}
	// This is a little strange code, but it can find the destintation folder as nsIFile
	// without calling nsILocalFile.initwithPath. This is done creating a new subfolder,
	// finding the parent of this temp new subfolder and deleting the subfolder itself.
	// The 0.5.3 version did this scanning all the files into the directory, to find the directory
	// called "msgfoldername.sbd". But this doesn't work, because there is a case when
	// this directory can miss: when you've deleted before all the subfolders from the GUI,
	// without restarting.
	// This is a dirty hack, I hope to find in the future something better...
	//
	// 1. add a subfolder with the name of the folder to import
	var tempfolder = msgFolder.addSubfolder(newfilename);
	// 2. find the nsIFile of the directory where the file will be copied
	if (msgFolder.isServer) {
		var filex = msgFolder2LocalFile(msgFolder);
	}
	else {
		var tempfolderNS = msgFolder2LocalFile(tempfolder);
		var filex = tempfolderNS.parent;
	}
	// 3. delete the new subfolder, to delete all the files inside "msgfoldername.sbd" directory
	tempfolder.Delete();
	if (! filex) {
		alert(mboximportbundle.GetStringFromName("internalerror"));
		return false;
	}
	try {
		// Finally copy the mbox file in the "msgfoldername.sbd" directory
		file.copyTo(filex,newfilename);
		// If this is an export with structure, we try also to export the directory mbox-filename.sbd
		if (keepstructure) {
			var sbd = file.parent;
			sbd.append(file.leafName+".sbd");
			if (sbd.exists()) 
				sbd.copyTo(filex,newfilename+".sbd");
		}
	}
	catch(e) {
		return false;
	} 
	// inizialize as nsIFile the folder imported in TB and check if it's writable and readable.
	// if not (for ex. a file imported from a cdrom), change the permissions
	filex.append(newfilename)
	if (! filex.isReadable() || ! filex.isWritable() )
		filex.permissions = 420;
	// the following code of this subfunction has been written with the help of Frank Ausdilecce
	// really thanks for his help
	var newFolder = tempfolder;
	// this notifies listeners that a folder has been added;
	// the code is different for TB-1.0 and TB > 1.0 because the syntax of 
	// NotifyItemAdded seems to have been modified
	try {
	 	msgFolder.NotifyItemAdded(msgFolder,newFolder,"Folder Added"); // This is for TB1.0
	}
	catch(e) {}
	try {
		msgFolder.NotifyItemAdded(newFolder); // This is for TB > 1.0
	}
	catch(e) {}
	// this line *should* create the msf file
	newFolder.updateSummaryTotals(true);
	return newfilename;
}


// we need a short delay to close the dialog window, before show the filepicker
function preimportmbox(scandir, keepstructure,windialog) {
	if (scandir)
		window.setTimeout("importmbox(true, false)", 1000);
	else if (! scandir && keepstructure)
		window.setTimeout("importmbox(false,true)", 1000);
	else
		window.setTimeout("importmbox(false,false)", 1000);
}

// scandir flag is to know if the function must scan a directory or just import mbox file(s)
function importmbox(scandir,keepstructure) {
	// initialize variables
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	// we don't import the file in imap or nntp accounts
	if ( (msgFolder.server.type == "imap" ) || (msgFolder.server.type == "nntp" ) ) {
		alert(mboximportbundle.GetStringFromName("badfolder"));
		return;
	}
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	if (! scandir) {
		// open the filepicker	
		fp.init(window, mboximportbundle.GetStringFromName("filePickerImport"), nsIFilePicker.modeOpenMultiple);
		fp.appendFilters(nsIFilePicker.filterAll);
		var res=fp.show();
		if (res==nsIFilePicker.returnOK){
			// thefiles is the nsiSimpleEnumerator with the files selected from the filepicker
			var thefiles=fp.files;
			while(thefiles.hasMoreElements()) {
					var onefile= thefiles.getNext();
					onefile = onefile.QueryInterface(Components.interfaces.nsILocalFile);
					var mboxname=onefile.leafName;
					trytocopy(onefile,mboxname,msgFolder,keepstructure);
			}
		}
		else 
			return;
	}
	else {
		// Open the filepicker to choose the directory
		fp.init(window, mboximportbundle.GetStringFromName("searchdir"), nsIFilePicker.modeGetFolder);
		var res=fp.show();
		if (res==nsIFilePicker.returnOK){
			// allfiles is the nsiSimpleEnumerator with the files in the directory selected from the filepicker
			var allfiles = fp.file.directoryEntries;
			// scanning the directory to search files that could be mbox files
			while(allfiles.hasMoreElements()) {
				var afile= allfiles.getNext();
				afile = afile.QueryInterface(Components.interfaces.nsILocalFile);
				var mboxname=afile.leafName;
				if ( isMbox(afile) ) {
					var ask = gPrefBranch.getBoolPref("mboximport.confirm.before_mbox_import");
					if (ask) 
						var importThis = confirm(mboximportbundle.GetStringFromName("confirmimport")+ ' "'+
 mboxname + '" ?');
					else
						var importThis = true;
					if (importThis) 
						trytocopy(afile,mboxname,msgFolder);
				}
			}
			// alert(mboximportbundle.GetStringFromName("endscan"));
			IETwritestatus(mboximportbundle.GetStringFromName("endscan"));
		}
	}		
}


// The subfolder argument is true if we have to export also the subfolders
function exportfolder(subfolder, keepstructure) {
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	var isVirtualFolder = msgFolder ? msgFolder.flags & MSG_FOLDER_FLAG_VIRTUAL : false;
	// For virtual folders, it's used a different function
	if (isVirtualFolder) {
		exportVirtualFolder(folderResource,msgFolder);
		return;
	}
	var filex = msgFolder2LocalFile(msgFolder);
	// thefoldername=the folder name displayed in TB (for ex. "Modelli")
	var thefoldername = msgFolder.name;
	// Check if it's a newsgroup account/folder or a imap account/folder
	// If it's, the export function will be called only if the folder has offline support
	if ( (msgFolder.server.type == "imap" ) || (msgFolder.server.type == "nntp") ) {
		if (msgFolder.isServer || subfolder || keepstructure) {
			alert(mboximportbundle.GetStringFromName("isNewsgroup"));
			return;
		}
		// Offline flag test
		if ((msgFolder.flags & 0x8000000) == 0) {
			// This means that the folder has NOT been selected for offline use
			exportIMAPfolder(msgFolder, thefoldername);
                	return;
                }
	}
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	// Open the filepicker to choose the directory
	fp.init(window, mboximportbundle.GetStringFromName("filePickerExport"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK){
		var destdirNSIFILE = fp.fileURL.file;
		// Check if the directory is writable
		if ( ! destdirNSIFILE.isWritable()) {
				alert(mboximportbundle.GetStringFromName("nowritable")); 
				return;
		}
		// Check if we're exporting a simple mail folder, a folder with its subfolders or all the folders of the account
		if (msgFolder.isServer) {
			exportSubFolders(msgFolder, fp.file, destdirNSIFILE, keepstructure);
			IETwritestatus(mboximportbundle.GetStringFromName("exportOK"));
		}
		else if (subfolder && ! keepstructure) {
			// export the folder with the subfolders
			// first we copy the folder, finding a good name from its displayed name
			var newname =  findGoodName(thefoldername,destdirNSIFILE,false);
			filex.copyTo(fp.file,newname);
			// then we export the subfolders
			exportSubFolders(msgFolder, fp.file, destdirNSIFILE, keepstructure);
			IETwritestatus(mboximportbundle.GetStringFromName("exportOK"));
		}
		else if (subfolder && keepstructure) {
			var newname =  findGoodName(thefoldername,destdirNSIFILE,true);
			filex.copyTo(fp.file,newname);
			var sbd = filex.parent;
			sbd.append(filex.leafName+".sbd");
			if (sbd) {
				sbd.copyTo(fp.file,newname+".sbd");
				var destdirNsFile = fp.file;
				destdirNsFile.append(newname+".sbd");
				var listMSF = MBOXIMPORTscandir.find(destdirNsFile);
				for (i = 0; i < listMSF.length; ++i) {
					if (listMSF[i].leafName.substring(listMSF[i].leafName.lastIndexOf(".")) == ".msf") {
						try {	listMSF[i].remove(false); }
						catch(e) {}
					}
				}
			}
			IETwritestatus(mboximportbundle.GetStringFromName("exportOK"));
		}
		else {
			//export just the folder
			var newname =  findGoodName(thefoldername,destdirNSIFILE,false);
			filex.copyTo(fp.file,newname);
			IETwritestatus(mboximportbundle.GetStringFromName("exportOK"));
		}
	}
}

var MBOXIMPORTscandir = {
	list2 : [],

	find : function(dir) {
		var list = new Array();
		if (dir.isDirectory()) {
			var files = dir.directoryEntries;
			list = this.scanRecursive(files);
		}
	return list;
	},

	scanRecursive : function(dirEntry) {
		var list = new Array();
		while (dirEntry.hasMoreElements()) {
			list.push(dirEntry.getNext().QueryInterface(Components.interfaces.nsIFile));
		}
		for (var i = 0; i < list.length; ++i) {
			if (list[i].isDirectory()) {
				files = list[i].directoryEntries;
				this.list2 = this.scanRecursive(files);
			}
		}
		for (i = 0; i < this.list2.length; ++i) {
			list.push(this.list2[i]);
		}
		this.list2 = [];
		return list;
	}
};



function exportSubFolders(msgFolder, fpFile, destdirNSIFILE, keepstructure) {
	// Get the subfolders
	var subfolders = msgFolder.GetSubFolders();
	while(true) {
		var next = subfolders.currentItem();
		var subfolder = next.QueryInterface(Components.interfaces.nsIMsgFolder);
		// Search for a good name
		var newname = findGoodName(subfolder.name,destdirNSIFILE, false);
		var subfolderNS = msgFolder2LocalFile(subfolder);
		subfolderNS.copyTo(fpFile,newname);
		if (keepstructure) {
			var sbd = subfolderNS.parent;
			sbd.append(subfolderNS.leafName+".sbd");
			if (sbd.exists() && sbd.directoryEntries.hasMoreElements()) {
				sbd.copyTo(fpFile,newname+".sbd");
				var destdirNsFile = fpFile.clone();
				destdirNsFile.append(newname+".sbd");
				var listMSF = MBOXIMPORTscandir.find(destdirNsFile);
				for (i = 0; i < listMSF.length; ++i) {
					if (listMSF[i].leafName.substring(listMSF[i].leafName.lastIndexOf(".")) == ".msf") {
						try {	listMSF[i].remove(false); }
						catch(e) {}
					}
				}
			}
		}
		// If the subfolder has subfodlers, the function calls itself
		if (subfolder.hasSubFolders && ! keepstructure)
			 exportSubFolders(subfolder, fpFile, destdirNSIFILE);
		try { 
			subfolders.next(); 
		} 
		catch(ex) { 
			break; 
		}
	}
}
	

function findGoodName(foldername,destdirNSIFILE,structure) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var overwrite = prefs.getBoolPref("mboximport.export.overwrite");
	var index = 0;
	var nameIndex = "";
	var NSclone = destdirNSIFILE.clone();
	NSclone.append(foldername);
	// Change unsafe chars for filenames with underscore
	foldername = nametoascii(foldername);
	// foldername = foldername.replace(/[:?"\*\/<>#]/g, "_");
	// if the user wants to overwrite the files with the same name in the folder destination
	// the function must delete the existing files and then return the original filename.
	// If it's a structured export, it's deleted also the filename.sbd subdirectory
	if (overwrite) {
		if (NSclone.exists()) {
			NSclone.remove(false);
			if (structure) {
				var NSclone2 = destdirNSIFILE.clone();
				NSclone2.append(foldername+".sbd");
				NSclone2.remove(true);
			}
		}				 
		return foldername;
	}
	var NSclone = destdirNSIFILE.clone();
	NSclone.append(foldername);
	while (NSclone.exists()) {
		index++;
		nameIndex = foldername + "-"+index.toString();
		NSclone = destdirNSIFILE.clone();
		NSclone.append(nameIndex);
	}
	if (nameIndex != "")
		return nameIndex;
	else
		return foldername;
}


function isMbox(file) {
	if (file.isDirectory() || ! file.exists())
		return false;
	// check if the file is a mbox file, reading the first 4 chars.
	// a mbox file must begin with "From"
	var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                .createInstance(Components.interfaces.nsIFileInputStream);
	istream.init(file, 0x01, 0444, 0);
	istream.QueryInterface(Components.interfaces.nsILineInputStream);
	var line = {};
	istream.readLine(line);
	istream.close();
	var first4chars = line.value.substring(0,4);
	if ( first4chars != "From" )
		return false;
	else
		return true;
}

function importALLasEML() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	// Open the filepicker to choose the directory
	fp.init(window, mboximportbundle.GetStringFromName("searchdir"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK){
		// allfiles is the nsiSimpleEnumerator with the files in the directory selected from the filepicker
		var allfiles = fp.file.directoryEntries;
		// scanning the directory to search files that could be mbox files
		while(allfiles.hasMoreElements()) {
			var afile= allfiles.getNext();
			afile = afile.QueryInterface(Components.interfaces.nsILocalFile);
			var afilename=afile.leafName;
			var afilenameext = afilename.substring(afilename.lastIndexOf("."), afilename.length);
			if ( ! afile.isFile() ||  afilenameext != ".eml" )
				continue;
			var folderResource = GetSelectedFolderResource();
			var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
			trytoimportEML(afile,msgFolder,false);
		}
	}
}

function importEMLs() {
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	// No import for imap and news account, sorry...
	if ( (msgFolder.server.type == "imap" ) || (msgFolder.server.type == "nntp" ) ) {
		alert(mboximportbundle.GetStringFromName("badfolder"));
		return;
	}
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, mboximportbundle.GetStringFromName("filePickerImport"), nsIFilePicker.modeOpenMultiple);
	fp.appendFilter("Email files", "*.eml");
	var res=fp.show();
	if (res==nsIFilePicker.returnOK){
		var thefiles=fp.files;
			// For every EML it's called the import function
			while(thefiles.hasMoreElements()) {
					var onefile= thefiles.getNext();
					onefile = onefile.QueryInterface(Components.interfaces.nsILocalFile);
					trytoimportEML(onefile,msgFolder,false);
			}
		// At the end we update the fodler view and summary
		msgFolder.updateFolder(msgWindow);
		msgFolder.updateSummaryTotals(true);
	}
}

function importEMLlistener() {}

importEMLlistener.prototype = {
	onStartRequest: function (aRequest, aContext) {
		    this.mData = "";
	},
	
	onDataAvailable: function (aRequest, aContext, aStream, aSourceOffset, aLength) {
		var scriptableInputStream =  Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableInputStream.init(aStream);
		var data = scriptableInputStream.read(aLength);
		this.mData += data;
	},

	onStopRequest: function (aRequest, aContext, aStatus) {
		writeDataToFolder(this.mData, this.msgFolder,this.file,this.removeFile);
	},

	QueryInterface : function(aIID) {
		if (aIID.equals(Components.interfaces.nsISupports) ||
	        aIID.equals(Components.interfaces.nsIInterfaceRequestor) ||
	        aIID.equals(Components.interfaces.nsIChannelEventSink) || 
	        aIID.equals(Components.interfaces.nsIProgressEventSink) ||
	        aIID.equals(Components.interfaces.nsIHttpEventSink) ||
	        aIID.equals(Components.interfaces.nsIStreamListener))
	      return this;

	    throw Components.results.NS_NOINTERFACE;
	}
};

function trytoimportEML(file,msgFolder,removeFile) {
	gEMLimported = 0;
	IETwritestatus(mboximportbundle.GetStringFromName("importEMLstart")); 
	var msgLocalFolder = msgFolder.QueryInterface(Components.interfaces.nsIMsgLocalMailFolder);
	var data = "";
	// Put all the text of the EML file in "data" variable
	// var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
        //               .createInstance(Components.interfaces.nsIFileInputStream);
	// var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
        //              .createInstance(Components.interfaces.nsIScriptableInputStream);
	// fstream.init(file, -1, 0, 0);
	// sstream.init(fstream); 
	// var str = sstream.read(4096);
	// while (str.length > 0) {
	//	data += str;
	//	str = sstream.read(4096);
	// }
	// sstream.close();
	// fstream.close();

	var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
	var fileURI = ios.newFileURI(file);
	var channel = ios.newChannelFromURI(fileURI);
	var listener = new importEMLlistener();
	listener.msgFolder = msgFolder;
	listener.removeFile = removeFile;
	listener.file = file;
	channel.asyncOpen(listener, null);
}

function writeDataToFolder(data,msgFolder,file,removeFile) {
	var msgLocalFolder = msgFolder.QueryInterface(Components.interfaces.nsIMsgLocalMailFolder);
	var now = new Date;
	// Prologue needed to add the message to the folder
	var prologue = "From - " + now.toString() + "\n"; // The first line must begin with "From -", the following is not important
	// If the message has no X-Mozilla-Status, we add them to it
	if (data.indexOf("X-Mozilla-Status") < 0) 
		var prologue = prologue + "X-Mozilla-Status: 0001\nX-Mozilla-Status2: 00000000\n";
	// If the message has no X-Account-Key, we add it to it, taking it from the account selected
	if (data.indexOf("X-Account-Key") < 0) {
		var myAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
			.getService(Components.interfaces.nsIMsgAccountManager);
		var myAccount = myAccountManager.FindAccountForServer(msgFolder.server);
		prologue = prologue + "X-Account-Key: " + myAccount.key + "\n";
	}
	data = IETescapeBeginningFrom(data);
	// Add the prologue to the EML text
	data = prologue + data + "\n";
	// Add the email to the folder
	msgLocalFolder.addMessage(data);
	gEMLimported = gEMLimported + 1;
	IETwritestatus(mboximportbundle.GetStringFromName("numEML")+gEMLimported); 
	if (removeFile)
		file.remove(false);
}

var IETtempfilesize;
var IETcount;

function importEmlToFolder() {
	// To import an eml attachment in folder, as a real message, it's necessary to save it
	// in a temporary file in temp directory
	var restoreDownloadWindowPref = false;
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	var isVirtFol = msgFolder ? msgFolder.flags & MSG_FOLDER_FLAG_VIRTUAL : false;
	if ( (msgFolder.server.type != "pop3" &&  msgFolder.server.type != "none") || isVirtFol) {
		alert(mboximportbundle.GetStringFromName("badfolder2"));
		return;
	}
	var item = document.getElementById("attachmentList").selectedItem;
	var attachment = item.attachment;
	var tempdir = Components.classes["@mozilla.org/file/directory_service;1"]
                    .getService(Components.interfaces.nsIProperties)
                    .get("TmpD", Components.interfaces.nsIFile);
	
	// This code is needed to fix the bug of nsIMessenger.saveAttachmentToFolder, that on TB 1.5 or lower
	// saves the attachment not in nsIFile but in its parent directory
	try {
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
                        .getService(Components.interfaces.nsIXULAppInfo);
		var version = appInfo.version.toString();
		if (version.indexOf("1") == 0)
			tempdir.append("dummySubDir");
	}
	catch(e) {
		tempdir.append("dummySubDir");
	}
	
	// Hide download window, if necessary (TB2 only)
	try {
		var downloadWindowPref = gPrefBranch.getBoolPref("browser.download.manager.useWindow");
		if (downloadWindowPref) {
			gPrefBranch.setBoolPref("browser.download.manager.useWindow", false);
			restoreDownloadWindowPref = true;
		}
	}
	catch(e) {}
	IETtempfilesize = -1;
	IETcount = 0;
	try {
		var tempfile = messenger.saveAttachmentToFolder(attachment.contentType , attachment.url , encodeURIComponent(attachment.displayName), attachment.messageUri , tempdir);
		window.setTimeout(checkToImportEMLattach,1000,tempfile,msgFolder);
	}
	catch(e) {
		alert(mboximportbundle.GetStringFromName("temp_error"));
	}
	if (restoreDownloadWindowPref)
		window.setTimeout(function() {gPrefBranch.setBoolPref("browser.download.manager.useWindow", true);}, 500);
}

function checkToImportEMLattach(file,msgFolder) {
	// To see if the download is finished, the extension checks the filesize
	// every second, for 20 times (20 sec. are enough for every attachment)
	if (! file.exists())
		return;
	if (file.fileSize != IETtempfilesize) {
		IETtempfilesize = file.fileSize;
		if (IETcount < 20) {
			IETcount++;
			window.setTimeout(checkToImportEMLattach,1000,file,msgFolder);
		}
		else
			file.remove(false);
		return;
	}
	// The download is finished, call the eml import function, with the "delete-file" option
	trytoimportEML(file, msgFolder, true);
}	
	
